
;CodeVisionAVR C Compiler V2.05.0 Professional
;(C) Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega328P
;Program type             : Application
;Clock frequency          : 16,000000 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 512 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: No
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega328P
	#pragma AVRPART MEMORY PROG_FLASH 32768
	#pragma AVRPART MEMORY EEPROM 1024
	#pragma AVRPART MEMORY INT_SRAM SIZE 2303
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x100

	#define CALL_SUPPORTED 1

	.LISTMAC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU EECR=0x1F
	.EQU EEDR=0x20
	.EQU EEARL=0x21
	.EQU EEARH=0x22
	.EQU SPSR=0x2D
	.EQU SPDR=0x2E
	.EQU SMCR=0x33
	.EQU MCUSR=0x34
	.EQU MCUCR=0x35
	.EQU WDTCSR=0x60
	.EQU UCSR0A=0xC0
	.EQU UDR0=0xC6
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.EQU GPIOR0=0x1E

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0100
	.EQU __SRAM_END=0x08FF
	.EQU __DSTACK_SIZE=0x0200
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;GPIOR0 INITIALIZATION VALUE
	.EQU __GPIOR0_INIT=0x00

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	JMP  __RESET
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  _adc_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00

_0x83:
	.DB  0x0,0x11,0x11,0x11,0x13,0x1D,0x10,0x10
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0
_0x0:
	.DB  0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20
	.DB  0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20
	.DB  0x0,0x46,0x3D,0x0,0x31,0x4D,0x48,0x7A
	.DB  0x20,0x20,0x20,0x0,0x32,0x35,0x30,0x4B
	.DB  0x48,0x7A,0x20,0x0,0x36,0x32,0x4B,0x48
	.DB  0x7A,0x20,0x20,0x0,0x31,0x36,0x4B,0x48
	.DB  0x7A,0x20,0x20,0x0,0x34,0x4B,0x48,0x7A
	.DB  0x20,0x20,0x20,0x0,0x31,0x4B,0x48,0x7A
	.DB  0x20,0x20,0x20,0x0,0x32,0x35,0x30,0x48
	.DB  0x7A,0x20,0x20,0x0,0x36,0x32,0x48,0x7A
	.DB  0x20,0x20,0x20,0x0,0x31,0x35,0x48,0x7A
	.DB  0x20,0x20,0x20,0x0,0x41,0x44,0x43,0x3D
	.DB  0x0,0x43,0x20,0x0,0x4C,0x20,0x0,0x30
	.DB  0x2E,0x30,0x30,0x30,0x2C,0x30,0x0,0x30
	.DB  0x2C,0x0,0x70,0x46,0x0,0x43,0x61,0x6C
	.DB  0x69,0x62,0x20,0x43,0x20,0x2D,0x20,0x6F
	.DB  0x70,0x65,0x6E,0x0,0x43,0x61,0x6C,0x69
	.DB  0x62,0x20,0x4C,0x20,0x2D,0x20,0x73,0x68
	.DB  0x6F,0x72,0x74,0x0,0x57,0x61,0x69,0x74
	.DB  0x2E,0x2E,0x2E,0x0,0x44,0x6F,0x6E,0x65
	.DB  0x20,0x20,0x20,0x0,0x45,0x72,0x72,0x6F
	.DB  0x72,0x20,0x0
_0x2000060:
	.DB  0x1
_0x2000000:
	.DB  0x2D,0x4E,0x41,0x4E,0x0,0x49,0x4E,0x46
	.DB  0x0

__GLOBAL_INI_TBL:
	.DW  0x11
	.DW  _0x57
	.DW  _0x0*2

	.DW  0x03
	.DW  _0x58
	.DW  _0x0*2+17

	.DW  0x08
	.DW  _0x58+3
	.DW  _0x0*2+20

	.DW  0x08
	.DW  _0x58+11
	.DW  _0x0*2+28

	.DW  0x08
	.DW  _0x58+19
	.DW  _0x0*2+36

	.DW  0x08
	.DW  _0x58+27
	.DW  _0x0*2+44

	.DW  0x08
	.DW  _0x58+35
	.DW  _0x0*2+52

	.DW  0x08
	.DW  _0x58+43
	.DW  _0x0*2+60

	.DW  0x08
	.DW  _0x58+51
	.DW  _0x0*2+68

	.DW  0x08
	.DW  _0x58+59
	.DW  _0x0*2+76

	.DW  0x08
	.DW  _0x58+67
	.DW  _0x0*2+84

	.DW  0x05
	.DW  _0x58+75
	.DW  _0x0*2+92

	.DW  0x03
	.DW  _0x68
	.DW  _0x0*2+97

	.DW  0x03
	.DW  _0x68+3
	.DW  _0x0*2+100

	.DW  0x08
	.DW  _0x68+6
	.DW  _0x0*2+103

	.DW  0x03
	.DW  _0x68+14
	.DW  _0x0*2+14

	.DW  0x07
	.DW  _0x68+17
	.DW  _0x0*2+104

	.DW  0x05
	.DW  _0x68+24
	.DW  _0x0*2+106

	.DW  0x04
	.DW  _0x68+29
	.DW  _0x0*2+107

	.DW  0x03
	.DW  _0x68+33
	.DW  _0x0*2+14

	.DW  0x03
	.DW  _0x68+36
	.DW  _0x0*2+108

	.DW  0x03
	.DW  _0x68+39
	.DW  _0x0*2+111

	.DW  0x03
	.DW  _0x68+42
	.DW  _0x0*2+114

	.DW  0x0F
	.DW  _0x94
	.DW  _0x0*2+117

	.DW  0x10
	.DW  _0x94+15
	.DW  _0x0*2+132

	.DW  0x08
	.DW  _0x94+31
	.DW  _0x0*2+148

	.DW  0x08
	.DW  _0x94+39
	.DW  _0x0*2+156

	.DW  0x07
	.DW  _0x94+47
	.DW  _0x0*2+164

	.DW  0x01
	.DW  __seed_G100
	.DW  _0x2000060*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  MCUCR,R31
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	WDR
	IN   R26,MCUSR
	CBR  R26,8
	OUT  MCUSR,R26
	STS  WDTCSR,R31
	STS  WDTCSR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,LOW(__SRAM_START)
	LDI  R27,HIGH(__SRAM_START)
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;GPIOR0 INITIALIZATION
	LDI  R30,__GPIOR0_INIT
	OUT  GPIOR0,R30

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x300

	.CSEG
;/*****************************************************
;This program was produced by the
;CodeWizardAVR V2.05.0 Professional
;Automatic Program Generator
; Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;
;Project : LCmeter-2
;Version : 1.0
;Date    : 17.10.2018
;Author  : RA4NAL
;Company : Home
;Comments:
;
;Chip type               : ATmega328P
;Program type            : Application
;AVR Core Clock frequency: 16,000000 MHz
;Memory model            : Small
;External RAM size       : 0
;Data Stack size         : 512
;
;Connections to ArduinoProMini
;
;Line    |    Port ATmega328    | Pin
;--------|----------------------|----
;ADC     |   ADC1 - PC1 IN AN   | A1
;FRQ     |   OC1B - PB2 OUT 0   | D10
;L/C     |          PD2 IN P D  | D2
;0       |   INT1 - PD3 IN P D  | D3
;        |                      |
;DB4     |          PD4 OUT 0   | D4
;DB5     |          PD5 OUT 0   | D5
;DB6     |          PD6 OUT 0   | D6
;DB7     |          PD7 OUT 0   | D7
;RS      |          PB0 OUT 0   | D8
;E       |          PB1 OUT 0   | D9
;------------------------------------
;LED     |          PB5 OUT 0   |
;Not Used|       Others IN P D  |
;***********************************************/
;
;#include <mega328p.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x01
	.EQU __sm_mask=0x0E
	.EQU __sm_adc_noise_red=0x02
	.EQU __sm_powerdown=0x04
	.EQU __sm_powersave=0x06
	.EQU __sm_standby=0x0C
	.EQU __sm_ext_standby=0x0E
	.SET power_ctrl_reg=smcr
	#endif
;#include <delay.h>
;#include <stdlib.h>
;#include <string.h>
;
;#define NMAX  8        // max diap
;#define maxCAL 0xC0    // max Calib value
;#define defCAL 0x0A    // default Calib value
;#define Umax 0x0380    // U max for band
;#define Umin 0x00C0    // U min for band
;
;#define pin_LC PIND.2  // L/C
;#define pin_0  PIND.3  // Button "Set 0" (INT1)
;
;// ADC interrupt service routine
;interrupt [ADC_INT] void adc_isr(void)
; 0000 003A   {

	.CSEG
_adc_isr:
; 0000 003B // reti
; 0000 003C   }
	RETI
;
;#include "lcm_asm.c"    // asm
;#pragma warn-             // this will prevent warnings
;// Start measuring
;unsigned int RchF(unsigned char Ndiap, unsigned char Nmax)
; 0000 003E   {
_RchF:
;#asm volatile
;	Ndiap -> Y+1
;	Nmax -> Y+0

.equ   PINB = 0x03
.equ   PINB2 = 0x02
.equ   ADCL = 0x78
.equ   ADCH = 0x79
.equ   TCCR1B = 0x81
.equ   TCNT1L = 0x84
.equ   TCNT1H = 0x85
.equ   OCR1AL = 0x88
.equ   OCR1AH = 0x89
.equ   OCR1BL = 0x8A
.equ   OCR1BH = 0x8B

.equ   ConstF = 0x08      ; const for ~1MHz if CK=16MHz (0x0A for 800 KHz)
.equ   Conzad = 50        ; const: delay=Conzad*0,01 sec

       ld    R30,Y        ; Nmax
       ldd   R31,Y+1      ; Ndiap
       ldi   R26,ConstF   ; LSB ConstF
       clr   R27          ; MSB ConstF
       cp    R30,R31      ; Nmax-Ndiap
       brcc  RCH1         ; Ndiap=<Nmax
       mov   R31,R30      ; Ndiap>Nmax, so Ndiap=Nmax
RCH1:  mov   R25,R31      ; Ndiap, do not change R31
       ldi   R24,0x09     ; (CS12:CS10)=001, WGM12=1 - mode CTC, no prescaling
RCH4:  tst   R25
       breq  RCH2         ; R25=0
       dec   R25          ; counter
       clc                ; C=0
       rol   R26          ; (R27:R26)*2 (ConstF*2)
       rol   R27          ; ///////////
       brcc  RCH3         ; C=0
RCH5:  ror   R27          ; C=1, restore R27:R26
       ror   R26          ; ///////////
       inc   R25          ; restore R25
       rjmp  RCH2
RCH3:  rol   R26          ; (R27:R26)*2 (total (R27:R26)*4)
       rol   R27          ; ///////////
       brcc  RCH4         ; C=0, multiply once more
       breq  RCH2         ; R27=0 (and R26=0)
       ror   R27          ; C=1, restore R27:R26
       ror   R26          ; ///////////
       rjmp  RCH5
RCH2:  tst   R25
       breq  RCH6         ; R25=0, calculation completed
       ldi   R24,0x0C     ; (CS12:CS10)=100, WGM12=1 - mode CTC, prescaling 1/256
       mov   R26,R27      ; ConstF/256
       clr   R27          ; //////////
       rjmp  RCH4         ; continue calculating
RCH6:  sbiw  R26,0x01     ; (R27:R26)-1
       clr   R25
       sts   OCR1BH,R27
       sts   OCR1AH,R27
       sts   OCR1BL,R26
       sts   OCR1AL,R26
       sts   TCNT1H,R25
       sts   TCNT1L,R25
       sts   TCCR1B,R24   ; start TMR1

; Wait ~ 0,5 sec
       ldi   R25,Conzad
RCH10: ldi   R26,125
       clr   R27
RCH11: rjmp  PC+1
       dec   R27
       brne  RCH11
       dec   R26
       brne  RCH11        ; ~0,01 s
       dec   R25
       brne  RCH10        ; ~Conzad * 0,01 s
       subi  R30,2        ; Nmax-2
       cp    R31,R30      ; Ndiap-(Nmax-2)
       brcs  DACON        ; C=1, Ndiap<(Nmax-2)
       sbic  PINB,PINB2   ; PB2=0
       rjmp  PC-1         ; wait PB2=0
       sbis  PINB,PINB2   ; PB2=1
       rjmp  PC-1         ; wait PB2=1

; Wait ~6 ms
       ldi   R27,0x80
       clr   R26
RCH9:  dec   R26
       brne  RCH9
       dec   R27
       brne  RCH9
DACON: ldi   R27,0x03
       out   SMCR,R27     ; SLEEP - inable, ADC Noise Reduction
       sleep              ; start ADC
       ldi   R27,0x02     ; 0100.0011
       out   SMCR,R27     ; SLEEP - disable
       lds   R30,ADCL     ; LSB
       lds   R31,ADCH     ; MSB

;  }
	RJMP _0x2080001
;#pragma warn+             // enable warnings
;
;#include "lcd.c"        // LCD & EEPROM
;/***************** LCD interface *****************
;* This code will interface to a standard LCD controller
;* like the Hitachi HD44780. It uses LCD display in 4 bit mode, with
;* the hardware connected as follows:
;* PORTD bits 4-7 are connected to the LCD data bits 4-7 (high nibble)
;* PORTB bit 0 is connected to the LCD RS input (register select)
;* PORTB bit 1 is connected to the LCD EN bit (enable)
;**************************************************/
;
;#define LCD_RS PORTB.0    // Register select
;#define LCD_EN PORTB.1    // Enable
;#define LCD_D4 PORTD.4    // Data bits
;#define LCD_D5 PORTD.5    // Data bits
;#define LCD_D6 PORTD.6    // Data bits
;#define LCD_D7 PORTD.7    // Data bits
;
;// Strob LCD
;void LCD_STROBE(void)
; 0000 003F   {
_LCD_STROBE:
;    LCD_EN = 1;
	SBI  0x5,1
;    delay_us(5);
	__DELAY_USB 27
;    LCD_EN = 0;
	CBI  0x5,1
;    delay_us(40);
	__DELAY_USB 213
;  }
	RET
;
;// write a byte to the LCD in 4 bit mode
;void lcd_write(unsigned char c)
;  {
_lcd_write:
;    if(c & 0x80) LCD_D7=1; else LCD_D7=0;
;	c -> Y+0
	LD   R30,Y
	ANDI R30,LOW(0x80)
	BREQ _0x7
	SBI  0xB,7
	RJMP _0xA
_0x7:
	CBI  0xB,7
;    if(c & 0x40) LCD_D6=1; else LCD_D6=0;
_0xA:
	LD   R30,Y
	ANDI R30,LOW(0x40)
	BREQ _0xD
	SBI  0xB,6
	RJMP _0x10
_0xD:
	CBI  0xB,6
;    if(c & 0x20) LCD_D5=1; else LCD_D5=0;
_0x10:
	LD   R30,Y
	ANDI R30,LOW(0x20)
	BREQ _0x13
	SBI  0xB,5
	RJMP _0x16
_0x13:
	CBI  0xB,5
;    if(c & 0x10) LCD_D4=1; else LCD_D4=0;
_0x16:
	LD   R30,Y
	ANDI R30,LOW(0x10)
	BREQ _0x19
	SBI  0xB,4
	RJMP _0x1C
_0x19:
	CBI  0xB,4
;    LCD_STROBE();
_0x1C:
	RCALL _LCD_STROBE
;    if(c & 0x08) LCD_D7=1; else LCD_D7=0;
	LD   R30,Y
	ANDI R30,LOW(0x8)
	BREQ _0x1F
	SBI  0xB,7
	RJMP _0x22
_0x1F:
	CBI  0xB,7
;    if(c & 0x04) LCD_D6=1; else LCD_D6=0;
_0x22:
	LD   R30,Y
	ANDI R30,LOW(0x4)
	BREQ _0x25
	SBI  0xB,6
	RJMP _0x28
_0x25:
	CBI  0xB,6
;    if(c & 0x02) LCD_D5=1; else LCD_D5=0;
_0x28:
	LD   R30,Y
	ANDI R30,LOW(0x2)
	BREQ _0x2B
	SBI  0xB,5
	RJMP _0x2E
_0x2B:
	CBI  0xB,5
;    if(c & 0x01) LCD_D4=1; else LCD_D4=0;
_0x2E:
	LD   R30,Y
	ANDI R30,LOW(0x1)
	BREQ _0x31
	SBI  0xB,4
	RJMP _0x34
_0x31:
	CBI  0xB,4
;    LCD_STROBE();
_0x34:
	RCALL _LCD_STROBE
;  }
	RJMP _0x2080003
;
;// Clear and home the LCD
;void lcd_clear(void)
;  {
_lcd_clear:
;    LCD_RS = 0;
	CBI  0x5,0
;    lcd_write(0x1);
	CALL SUBOPT_0x0
;    delay_ms(50);
;  }
	RET
;
;// Write a string of chars to the LCD
;void lcd_puts(const char *s)
;  {
_lcd_puts:
;    LCD_RS = 1;    // write characters
;	*s -> Y+0
	SBI  0x5,0
;    while(*s) lcd_write(*s++);
_0x3B:
	LD   R26,Y
	LDD  R27,Y+1
	LD   R30,X
	CPI  R30,0
	BREQ _0x3D
	LD   R30,X+
	ST   Y,R26
	STD  Y+1,R27
	ST   -Y,R30
	RCALL _lcd_write
	RJMP _0x3B
_0x3D:
	RJMP _0x2080001
;
;// write one character to the LCD
;void lcd_putch(unsigned char c)
;  {
_lcd_putch:
;    LCD_RS = 1;    // write characters
;	c -> Y+0
	SBI  0x5,0
;    lcd_write(c);
	LD   R30,Y
	ST   -Y,R30
	RCALL _lcd_write
;  }
	RJMP _0x2080003
;
;// Go to the specified position
;void lcd_goto(unsigned char pos, unsigned char line)
;  {
_lcd_goto:
;    LCD_RS = 0;
;	pos -> Y+1
;	line -> Y+0
	CBI  0x5,0
;    if (line==0)
	LD   R30,Y
	CPI  R30,0
	BRNE _0x42
;      lcd_write(0x80 + pos);
	LDD  R30,Y+1
	SUBI R30,-LOW(128)
	RJMP _0xB6
;    else
_0x42:
;      lcd_write(0x80 + pos + 0x40);
	LDD  R30,Y+1
	SUBI R30,-LOW(192)
_0xB6:
	ST   -Y,R30
	RCALL _lcd_write
;  }
	RJMP _0x2080001
;
;// initialise the LCD - put into 4 bit mode
;void lcd_init(void)
;  {
_lcd_init:
;    LCD_RS = 0;    // write control bytes
	CBI  0x5,0
;    delay_ms(200); // power on delay
	LDI  R30,LOW(200)
	LDI  R31,HIGH(200)
	CALL SUBOPT_0x1
;    LCD_D4 = 1;    // init!
	SBI  0xB,4
;    LCD_D5 = 1;    //
	SBI  0xB,5
;    LCD_D6 = 0;    //
	CBI  0xB,6
;    LCD_D7 = 0;    //
	CBI  0xB,7
;    LCD_STROBE();
	CALL SUBOPT_0x2
;    delay_ms(40);
;    LCD_STROBE();  // init!
	CALL SUBOPT_0x2
;    delay_ms(40);
;    LCD_STROBE();  // init!
	CALL SUBOPT_0x2
;    delay_ms(40);
;    LCD_D4 = 0;    // set 4 bit mode
	CBI  0xB,4
;    LCD_STROBE();
	RCALL _LCD_STROBE
;    lcd_write(0x28); // 4 bit mode, 1/16 duty, 5x8 font, 2lines
	LDI  R30,LOW(40)
	ST   -Y,R30
	RCALL _lcd_write
;    lcd_write(0x08);
	LDI  R30,LOW(8)
	ST   -Y,R30
	RCALL _lcd_write
;    lcd_write(0x01); // clear display and reset cursor
	CALL SUBOPT_0x0
;    delay_ms(50);
;    lcd_write(0x06); // entry mode advance cursor
	LDI  R30,LOW(6)
	ST   -Y,R30
	RCALL _lcd_write
;    lcd_write(0x0C); // display on
	LDI  R30,LOW(12)
	ST   -Y,R30
	RCALL _lcd_write
;  }
	RET
;
;// Create simbol "mikro"
;
;void LCD_build(unsigned char *ptr)
;  {
_LCD_build:
;    unsigned char i;
;
;    LCD_RS = 0;
	ST   -Y,R17
;	*ptr -> Y+1
;	i -> R17
	CBI  0x5,0
;    lcd_write(0x40);      // point to CGRAM
	LDI  R30,LOW(64)
	ST   -Y,R30
	RCALL _lcd_write
;    LCD_RS = 1;
	SBI  0x5,0
;    for(i=0; i<8; i++)
	LDI  R17,LOW(0)
_0x55:
	CPI  R17,8
	BRSH _0x56
;      lcd_write(ptr[i]);
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	LD   R30,X
	ST   -Y,R30
	RCALL _lcd_write
	SUBI R17,-1
	RJMP _0x55
_0x56:
	LDD  R17,Y+0
	RJMP _0x2080002
;
;// Clear  line
;void lcd_spc(unsigned char line)
;  {
_lcd_spc:
;    lcd_goto(0,line);
;	line -> Y+0
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDD  R30,Y+1
	ST   -Y,R30
	RCALL _lcd_goto
;    lcd_puts("                ");
	__POINTW1MN _0x57,0
	CALL SUBOPT_0x3
;  }
_0x2080003:
	ADIW R28,1
	RET

	.DSEG
_0x57:
	.BYTE 0x11
;
;// Write Freq and Lim to display
;void lcd_frq(unsigned char Nd, unsigned int AdcR)
;  {

	.CSEG
_lcd_frq:
;    unsigned char buf[6];
;    lcd_spc(1);
	SBIW R28,6
;	Nd -> Y+8
;	AdcR -> Y+6
;	buf -> Y+0
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _lcd_spc
;    lcd_goto(0,1);
	CALL SUBOPT_0x4
;    lcd_puts("F=");
	__POINTW1MN _0x58,0
	CALL SUBOPT_0x3
;    if (Nd == 0) lcd_puts("1MHz   ");
	LDD  R30,Y+8
	CPI  R30,0
	BRNE _0x59
	__POINTW1MN _0x58,3
	CALL SUBOPT_0x3
;    if (Nd == 1) lcd_puts("250KHz ");
_0x59:
	LDD  R26,Y+8
	CPI  R26,LOW(0x1)
	BRNE _0x5A
	__POINTW1MN _0x58,11
	CALL SUBOPT_0x3
;    if (Nd == 2) lcd_puts("62KHz  ");
_0x5A:
	LDD  R26,Y+8
	CPI  R26,LOW(0x2)
	BRNE _0x5B
	__POINTW1MN _0x58,19
	CALL SUBOPT_0x3
;    if (Nd == 3) lcd_puts("16KHz  ");
_0x5B:
	LDD  R26,Y+8
	CPI  R26,LOW(0x3)
	BRNE _0x5C
	__POINTW1MN _0x58,27
	CALL SUBOPT_0x3
;    if (Nd == 4) lcd_puts("4KHz   ");
_0x5C:
	LDD  R26,Y+8
	CPI  R26,LOW(0x4)
	BRNE _0x5D
	__POINTW1MN _0x58,35
	CALL SUBOPT_0x3
;    if (Nd == 5) lcd_puts("1KHz   ");
_0x5D:
	LDD  R26,Y+8
	CPI  R26,LOW(0x5)
	BRNE _0x5E
	__POINTW1MN _0x58,43
	CALL SUBOPT_0x3
;    if (Nd == 6) lcd_puts("250Hz  ");
_0x5E:
	LDD  R26,Y+8
	CPI  R26,LOW(0x6)
	BRNE _0x5F
	__POINTW1MN _0x58,51
	CALL SUBOPT_0x3
;    if (Nd == 7) lcd_puts("62Hz   ");
_0x5F:
	LDD  R26,Y+8
	CPI  R26,LOW(0x7)
	BRNE _0x60
	__POINTW1MN _0x58,59
	CALL SUBOPT_0x3
;    if (Nd == 8) lcd_puts("15Hz   ");
_0x60:
	LDD  R26,Y+8
	CPI  R26,LOW(0x8)
	BRNE _0x61
	__POINTW1MN _0x58,67
	CALL SUBOPT_0x3
;    lcd_puts("ADC=");
_0x61:
	__POINTW1MN _0x58,75
	CALL SUBOPT_0x3
;    if (AdcR > 999)
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	CPI  R26,LOW(0x3E8)
	LDI  R30,HIGH(0x3E8)
	CPC  R27,R30
	BRLO _0x62
;       AdcR = 999;
	LDI  R30,LOW(999)
	LDI  R31,HIGH(999)
	STD  Y+6,R30
	STD  Y+6+1,R31
;    itoa(AdcR, buf);
_0x62:
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,2
	ST   -Y,R31
	ST   -Y,R30
	CALL _itoa
;    lcd_puts(buf);
	MOVW R30,R28
	CALL SUBOPT_0x3
;  }
	ADIW R28,9
	RET

	.DSEG
_0x58:
	.BYTE 0x50
;
;// Leave only 3 significant digits
;unsigned char prpeLC(unsigned char *string)
;  {

	.CSEG
_prpeLC:
;    unsigned char len;
;
;    len = strlen(string);      // length of string
	ST   -Y,R17
;	*string -> Y+1
;	len -> R17
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	ST   -Y,R31
	ST   -Y,R30
	CALL _strlen
	MOV  R17,R30
;    if (len > 3)
	CPI  R17,4
	BRLO _0x63
;      {
;        if (string[3] >= 0x35)
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	ADIW R26,3
	LD   R26,X
	CPI  R26,LOW(0x35)
	BRLO _0x64
;         {
;            string[2] = string[2] + 1;
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	ADIW R26,2
	LD   R30,X
	SUBI R30,-LOW(1)
	__PUTB1SNS 1,2
;            if (string[2] > 0x39)                    // "9"
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	ADIW R26,2
	LD   R26,X
	CPI  R26,LOW(0x3A)
	BRLO _0x65
;               {
;                  string[2] = 0x30;                  // "0"
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	ADIW R26,2
	LDI  R30,LOW(48)
	ST   X,R30
;                  string[1] = string[1] + 1;
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	ADIW R26,1
	LD   R30,X
	SUBI R30,-LOW(1)
	__PUTB1SNS 1,1
;                  if (string[1] > 0x39)              // "9"
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	ADIW R26,1
	LD   R26,X
	CPI  R26,LOW(0x3A)
	BRLO _0x66
;                     {
;                        string[1] = 0x30;            // "0"
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	ADIW R26,1
	LDI  R30,LOW(48)
	ST   X,R30
;                        string[0] = string[0] + 1;
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R30,X
	SUBI R30,-LOW(1)
	ST   X,R30
;                     }
;               }
_0x66:
;         }
_0x65:
;      }
_0x64:
;    return len;
_0x63:
	MOV  R30,R17
	LDD  R17,Y+0
	RJMP _0x2080002
;  }
;
;// output string to indicator
;void outIND(unsigned char *string0, unsigned char len, unsigned char znak)
;  {
_outIND:
;    lcd_goto(0,0);
;	*string0 -> Y+2
;	len -> Y+1
;	znak -> Y+0
	CALL SUBOPT_0x5
;    if (pin_LC == 0)
	SBIC 0x9,2
	RJMP _0x67
;        lcd_puts("C ");            // Mode "C"
	__POINTW1MN _0x68,0
	RJMP _0xB7
;    else  lcd_puts("L ");          // Mode "L"
_0x67:
	__POINTW1MN _0x68,3
_0xB7:
	ST   -Y,R31
	ST   -Y,R30
	RCALL _lcd_puts
;
;    if (len == 8)
	LDD  R26,Y+1
	CPI  R26,LOW(0x8)
	BRNE _0x6A
;      {
;        lcd_putch(string0[0]);
	CALL SUBOPT_0x6
;        lcd_putch('.');
	CALL SUBOPT_0x7
;        lcd_putch(string0[1]);
	CALL SUBOPT_0x8
;        lcd_putch(string0[2]);
;        lcd_puts("0.000,0");
	__POINTW1MN _0x68,6
	CALL SUBOPT_0x3
;      }
;    if (len < 8)
_0x6A:
	LDD  R26,Y+1
	CPI  R26,LOW(0x8)
	BRSH _0x6B
;        lcd_puts("  ");
	__POINTW1MN _0x68,14
	CALL SUBOPT_0x3
;
;    if (len == 7)
_0x6B:
	LDD  R26,Y+1
	CPI  R26,LOW(0x7)
	BRNE _0x6C
;      {
;        lcd_putch(string0[0]);
	CALL SUBOPT_0x6
;        lcd_putch(string0[1]);
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	CALL SUBOPT_0x8
;        lcd_putch(string0[2]);
;        lcd_puts(".000,0");
	__POINTW1MN _0x68,17
	CALL SUBOPT_0x3
;      }
;    if (len < 7)
_0x6C:
	LDD  R26,Y+1
	CPI  R26,LOW(0x7)
	BRSH _0x6D
;        lcd_putch(0x20);
	CALL SUBOPT_0x9
;
;    if (len == 6)
_0x6D:
	LDD  R26,Y+1
	CPI  R26,LOW(0x6)
	BRNE _0x6E
;      {
;        lcd_putch(string0[0]);
	CALL SUBOPT_0x6
;        lcd_putch(string0[1]);
	CALL SUBOPT_0xA
;        lcd_putch('.');
	CALL SUBOPT_0x7
;        lcd_putch(string0[2]);
	LDD  R26,Z+2
	ST   -Y,R26
	RCALL _lcd_putch
;        lcd_puts("00,0");
	__POINTW1MN _0x68,24
	CALL SUBOPT_0x3
;      }
;    if (len < 6)
_0x6E:
	LDD  R26,Y+1
	CPI  R26,LOW(0x6)
	BRSH _0x6F
;        lcd_putch(0x20);
	CALL SUBOPT_0x9
;
;    if (len == 5)
_0x6F:
	LDD  R26,Y+1
	CPI  R26,LOW(0x5)
	BRNE _0x70
;      {
;        lcd_putch(string0[0]);
	CALL SUBOPT_0x6
;        lcd_putch('.');
	CALL SUBOPT_0x7
;        lcd_putch(string0[1]);
	CALL SUBOPT_0x8
;        lcd_putch(string0[2]);
;        lcd_puts("0,0");
	__POINTW1MN _0x68,29
	CALL SUBOPT_0x3
;      }
;    if (len < 5)
_0x70:
	LDD  R26,Y+1
	CPI  R26,LOW(0x5)
	BRSH _0x71
;        lcd_puts("  ");
	__POINTW1MN _0x68,33
	CALL SUBOPT_0x3
;
;    if (len == 4)
_0x71:
	LDD  R26,Y+1
	CPI  R26,LOW(0x4)
	BRNE _0x72
;      {
;        lcd_putch(string0[0]);
	CALL SUBOPT_0x6
;        lcd_putch(string0[1]);
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	CALL SUBOPT_0x8
;        lcd_putch(string0[2]);
;        lcd_puts(",0");
	__POINTW1MN _0x68,36
	CALL SUBOPT_0x3
;      }
;
;    if (len == 3)
_0x72:
	LDD  R26,Y+1
	CPI  R26,LOW(0x3)
	BRNE _0x73
;      {
;        if (znak)
	LD   R30,Y
	CPI  R30,0
	BREQ _0x74
;          lcd_putch('-');
	LDI  R30,LOW(45)
	RJMP _0xB8
;        else
_0x74:
;          lcd_putch(0x20);
	LDI  R30,LOW(32)
_0xB8:
	ST   -Y,R30
	RCALL _lcd_putch
;        lcd_putch(string0[0]);
	CALL SUBOPT_0x6
;        lcd_putch(string0[1]);
	CALL SUBOPT_0xA
;        lcd_putch(',');
	LDI  R30,LOW(44)
	ST   -Y,R30
	RCALL _lcd_putch
;        lcd_putch(string0[2]);
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	LDD  R26,Z+2
	ST   -Y,R26
	RCALL _lcd_putch
;      }
;
;    if (len < 3)
_0x73:
	LDD  R26,Y+1
	CPI  R26,LOW(0x3)
	BRSH _0x76
;      {
;        if (znak)
	LD   R30,Y
	CPI  R30,0
	BREQ _0x77
;          lcd_putch('-');
	LDI  R30,LOW(45)
	RJMP _0xB9
;        else
_0x77:
;          lcd_putch(0x20);
	LDI  R30,LOW(32)
_0xB9:
	ST   -Y,R30
	RCALL _lcd_putch
;      }
;
;    if (len == 2)
_0x76:
	LDD  R26,Y+1
	CPI  R26,LOW(0x2)
	BRNE _0x79
;      {
;        lcd_putch(string0[0]);
	CALL SUBOPT_0x6
;        lcd_putch(',');
	LDI  R30,LOW(44)
	ST   -Y,R30
	RCALL _lcd_putch
;        lcd_putch(string0[1]);
	CALL SUBOPT_0xA
;      }
;
;    if (len == 1)
_0x79:
	LDD  R26,Y+1
	CPI  R26,LOW(0x1)
	BRNE _0x7A
;      {
;        lcd_puts("0,");
	__POINTW1MN _0x68,39
	CALL SUBOPT_0x3
;        lcd_putch(string0[0]);
	CALL SUBOPT_0x6
;      }
;
;    if (pin_LC == 0)
_0x7A:
	SBIC 0x9,2
	RJMP _0x7B
;        lcd_puts("pF");       // Mode "C"
	__POINTW1MN _0x68,42
	CALL SUBOPT_0x3
;    else
	RJMP _0x7C
_0x7B:
;         {
;           lcd_putch(0x00);   // Mode "L"
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _lcd_putch
;           lcd_putch('H');
	LDI  R30,LOW(72)
	ST   -Y,R30
	RCALL _lcd_putch
;         }
_0x7C:
;    lcd_putch(0x20);
	CALL SUBOPT_0x9
;  }
	ADIW R28,4
	RET

	.DSEG
_0x68:
	.BYTE 0x2D
;
;/******************** EEPROM **************************/
;// EEPROM write
;void EEPROM_write(unsigned int uiAddress, unsigned char ucData)
;  {

	.CSEG
_EEPROM_write:
;    while(EECR & (1<<EEPE)); // Wait for completion of previous write
;	uiAddress -> Y+1
;	ucData -> Y+0
_0x7D:
	SBIC 0x1F,1
	RJMP _0x7D
;    EEAR = uiAddress;        // Set up address and Data Registers
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	OUT  0x21+1,R31
	OUT  0x21,R30
;    EEDR = ucData;           // ---------------------------------
	LD   R30,Y
	OUT  0x20,R30
;    EECR |= (1<<EEMPE);      // Write logical one to EEMPE
	SBI  0x1F,2
;    EECR |= (1<<EEPE);       // Start eeprom write by setting EEPE
	SBI  0x1F,1
;  }
_0x2080002:
	ADIW R28,3
	RET
;
;// EEPROM read
;unsigned char EEPROM_read(unsigned int uiAddress)
;  {
_EEPROM_read:
;    while(EECR & (1<<EEPE)); // Wait for completion of previous write
;	uiAddress -> Y+0
_0x80:
	SBIC 0x1F,1
	RJMP _0x80
;    EEAR = uiAddress;        // Set up address register
	LD   R30,Y
	LDD  R31,Y+1
	OUT  0x21+1,R31
	OUT  0x21,R30
;    EECR |= (1<<EERE);       // Start eeprom read by writing EERE
	SBI  0x1F,0
;    return EEDR;             // Return data from Data Register
	IN   R30,0x20
_0x2080001:
	ADIW R28,2
	RET
;  }
;
;
;void main(void)
; 0000 0042 {
_main:
; 0000 0043 // Declare your local variables here
; 0000 0044 unsigned char Ndiap = NMAX;
; 0000 0045 unsigned char Counter1 = 0;
; 0000 0046 unsigned char CalL[NMAX+1], CalC[NMAX+1];
; 0000 0047 unsigned char Flag, TMP;
; 0000 0048 unsigned int AdcRes;
; 0000 0049 unsigned long int Result;
; 0000 004A unsigned char strResult[9] = {0,0,0,0,0,0,0,0,0};  // string for long int
; 0000 004B unsigned char pattern[8]={0x00,0x11,0x11,0x11,0x13,0x1D,0x10,0x10};  // "mikro"
; 0000 004C 
; 0000 004D #include "initsfr_328.c"       // initialization SFR mega328
;// lcmeter_2 Init SFR
;
;// Crystal Oscillator division factor: 1
;#pragma optsize-
;CLKPR=0x80;
	SBIW R28,39
	LDI  R24,17
	LDI  R26,LOW(0)
	LDI  R27,HIGH(0)
	LDI  R30,LOW(_0x83*2)
	LDI  R31,HIGH(_0x83*2)
	CALL __INITLOCB
;	Ndiap -> R17
;	Counter1 -> R16
;	CalL -> Y+30
;	CalC -> Y+21
;	Flag -> R19
;	TMP -> R18
;	AdcRes -> R20,R21
;	Result -> Y+17
;	strResult -> Y+8
;	pattern -> Y+0
	LDI  R17,8
	LDI  R16,0
	LDI  R30,LOW(128)
	STS  97,R30
;CLKPR=0x00;
	LDI  R30,LOW(0)
	STS  97,R30
;#ifdef _OPTIMIZE_SIZE_
;#pragma optsize+
;#endif
;
;// Input/Output Ports initialization
;// Port B initialization
;// Func7=In Func6=In Func5=Out Func4=In Func3=In Func2=Out Func1=Out Func0=Out
;// State7=T State6=T State5=0 State4=P State3=P State2=0 State1=0 State0=0
;PORTB=0x18;
	LDI  R30,LOW(24)
	OUT  0x5,R30
;DDRB=0x27;
	LDI  R30,LOW(39)
	OUT  0x4,R30
;
;// Port C initialization
;// Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
;// State6=T State5=P State4=P State3=P State2=P State1=T State0=P
;PORTC=0x3D;
	LDI  R30,LOW(61)
	OUT  0x8,R30
;DDRC=0x00;
	LDI  R30,LOW(0)
	OUT  0x7,R30
;
;// Port D initialization
;// Func7=Out Func6=Out Func5=Out Func4=Out Func3=In Func2=In Func1=In Func0=In
;// State7=0 State6=0 State5=0 State4=0 State3=P State2=P State1=P State0=P
;PORTD=0x0F;
	LDI  R30,LOW(15)
	OUT  0xB,R30
;DDRD=0xF0;
	LDI  R30,LOW(240)
	OUT  0xA,R30
;
;// Timer/Counter 0 initialization
;// Clock source: System Clock
;// Clock value: Timer 0 Stopped
;// Mode: Normal top=0xFF
;// OC0A output: Disconnected
;// OC0B output: Disconnected
;TCCR0A=0x00;
	LDI  R30,LOW(0)
	OUT  0x24,R30
;TCCR0B=0x00;
	OUT  0x25,R30
;TCNT0=0x00;
	OUT  0x26,R30
;OCR0A=0x00;
	OUT  0x27,R30
;OCR0B=0x00;
	OUT  0x28,R30
;
;// Timer/Counter 1 initialization
;// Clock source: System Clock
;// Clock value: Timer1 Stopped
;// Mode: CTC top=OCR1A
;// OC1A output: Discon.
;// OC1B output: Toggle
;// Noise Canceler: Off
;// Input Capture on Falling Edge
;// Timer1 Overflow Interrupt: Off
;// Input Capture Interrupt: Off
;// Compare A Match Interrupt: Off
;// Compare B Match Interrupt: Off
;TCCR1A=0x10;
	LDI  R30,LOW(16)
	STS  128,R30
;TCCR1B=0x08;
	LDI  R30,LOW(8)
	STS  129,R30
;TCNT1H=0x00;
	LDI  R30,LOW(0)
	STS  133,R30
;TCNT1L=0x00;
	STS  132,R30
;ICR1H=0x00;
	STS  135,R30
;ICR1L=0x00;
	STS  134,R30
;OCR1AH=0x00;
	STS  137,R30
;OCR1AL=0x00;
	STS  136,R30
;OCR1BH=0x00;
	STS  139,R30
;OCR1BL=0x00;
	STS  138,R30
;GTCCR=0x00;
	OUT  0x23,R30
;
;// Timer/Counter 2 initialization
;// Clock source: System Clock
;// Clock value: Timer2 Stopped
;// Mode: Normal top=0xFF
;// OC2A output: Disconnected
;// OC2B output: Disconnected
;ASSR=0x00;
	STS  182,R30
;TCCR2A=0x00;
	STS  176,R30
;TCCR2B=0x00;
	STS  177,R30
;TCNT2=0x00;
	STS  178,R30
;OCR2A=0x00;
	STS  179,R30
;OCR2B=0x00;
	STS  180,R30
;
;// External Interrupt(s) initialization
;// INT0: Off
;// INT1: Off, the falling edge set EIFR.INTF1
;// Interrupt on any change on pins PCINT0-7: Off
;// Interrupt on any change on pins PCINT8-14: Off
;// Interrupt on any change on pins PCINT16-23: Off
;EICRA=0x08;
	LDI  R30,LOW(8)
	STS  105,R30
;EIMSK=0x00;
	LDI  R30,LOW(0)
	OUT  0x1D,R30
;PCICR=0x00;
	STS  104,R30
;EIFR =0x03; // Clear flags INTF1, INTF0
	LDI  R30,LOW(3)
	OUT  0x1C,R30
;
;// Timer/Counter 0 Interrupt(s) initialization
;TIMSK0=0x00;
	LDI  R30,LOW(0)
	STS  110,R30
;
;// Timer/Counter 1 Interrupt(s) initialization
;TIMSK1=0x00;
	STS  111,R30
;
;// Timer/Counter 2 Interrupt(s) initialization
;TIMSK2=0x00;
	STS  112,R30
;
;// USART initialization
;// USART disabled
;UCSR0B=0x00;
	STS  193,R30
;
;// Analog Comparator initialization
;// Analog Comparator: Off
;// Analog Comparator Input Capture by Timer/Counter 1: Off
;ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x30,R30
;ADCSRB=0x00;
	LDI  R30,LOW(0)
	STS  123,R30
;DIDR1=0x00;
	STS  127,R30
;
;// ADC initialization
;// ADC Clock frequency: 125,000 kHz
;// ADC Voltage Reference: AVCC pin
;// ADC Auto Trigger Source: ADC Stopped
;// Digital input buffers on ADC0: On, ADC1: Off, ADC2: On, ADC3: On
;// ADC4: On, ADC5: On
;DIDR0=0x02;
	LDI  R30,LOW(2)
	STS  126,R30
;ADMUX=0x41;   // AVcc, ADC1
	LDI  R30,LOW(65)
	STS  124,R30
;ADCSRA=0x8F;
	LDI  R30,LOW(143)
	STS  122,R30
;
;// SPI initialization
;// SPI disabled
;SPCR=0x00;
	LDI  R30,LOW(0)
	OUT  0x2C,R30
;
;// TWI initialization
;// TWI disabled
;TWCR=0x00;
	STS  188,R30
;
;// Disable EEPROM
;EECR=0x00;
	OUT  0x1F,R30
; 0000 004E #asm ("sei")
	sei
; 0000 004F 
; 0000 0050 // Read "0" value
; 0000 0051 for (TMP=0; TMP <= NMAX; TMP++ )
	LDI  R18,LOW(0)
_0x85:
	CPI  R18,9
	BRLO PC+3
	JMP _0x86
; 0000 0052    {
; 0000 0053      CalC[TMP] = EEPROM_read(TMP+1);         // "0" value for C
	CALL SUBOPT_0xB
	MOVW R26,R28
	ADIW R26,21
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	CALL SUBOPT_0xB
	ADIW R30,1
	CALL SUBOPT_0xC
	POP  R26
	POP  R27
	ST   X,R30
; 0000 0054      CalL[TMP] = EEPROM_read(TMP+NMAX+2);    // "0" value for L
	CALL SUBOPT_0xB
	MOVW R26,R28
	ADIW R26,30
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	CALL SUBOPT_0xB
	ADIW R30,10
	CALL SUBOPT_0xC
	POP  R26
	POP  R27
	ST   X,R30
; 0000 0055      if (CalC[TMP] >= maxCAL)
	CALL SUBOPT_0xB
	CALL SUBOPT_0xD
	LD   R26,X
	CPI  R26,LOW(0xC0)
	BRLO _0x87
; 0000 0056        {
; 0000 0057          CalC[TMP] = defCAL;
	CALL SUBOPT_0xB
	CALL SUBOPT_0xD
	LDI  R30,LOW(10)
	ST   X,R30
; 0000 0058          EEPROM_write((TMP+1), defCAL);
	CALL SUBOPT_0xB
	ADIW R30,1
	CALL SUBOPT_0xE
; 0000 0059        }
; 0000 005A      if (CalL[TMP] >= maxCAL)
_0x87:
	CALL SUBOPT_0xB
	CALL SUBOPT_0xF
	LD   R26,X
	CPI  R26,LOW(0xC0)
	BRLO _0x88
; 0000 005B        {
; 0000 005C          CalL[TMP] = defCAL;
	CALL SUBOPT_0xB
	CALL SUBOPT_0xF
	LDI  R30,LOW(10)
	ST   X,R30
; 0000 005D          EEPROM_write(TMP+NMAX+2, defCAL);
	CALL SUBOPT_0xB
	ADIW R30,10
	CALL SUBOPT_0xE
; 0000 005E        }
; 0000 005F    }
_0x88:
	SUBI R18,-1
	RJMP _0x85
_0x86:
; 0000 0060 
; 0000 0061 lcd_init();
	RCALL _lcd_init
; 0000 0062 LCD_build(pattern);            // create simbol "mikro"
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	RCALL _LCD_build
; 0000 0063 
; 0000 0064 while (1)
_0x89:
; 0000 0065   {
; 0000 0066     if (Ndiap > NMAX)
	CPI  R17,9
	BRLO _0x8C
; 0000 0067        Ndiap = NMAX;
	LDI  R17,LOW(8)
; 0000 0068     if (EIFR.INTF1)            // Push "Set 0"
_0x8C:
	SBIS 0x1C,1
	RJMP _0x8D
; 0000 0069 // Calibration C or L
; 0000 006A       {
; 0000 006B         TMP = 10;
	LDI  R18,LOW(10)
; 0000 006C         while (TMP)            // Wait for relese button
_0x8E:
	CPI  R18,0
	BREQ _0x90
; 0000 006D           {
; 0000 006E             delay_ms(2);
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	CALL SUBOPT_0x1
; 0000 006F             if (pin_0 == 0) TMP = 10;
	SBIC 0x9,3
	RJMP _0x91
	LDI  R18,LOW(10)
; 0000 0070             else --TMP;
	RJMP _0x92
_0x91:
	SUBI R18,LOW(1)
; 0000 0071           }
_0x92:
	RJMP _0x8E
_0x90:
; 0000 0072         lcd_clear();
	RCALL _lcd_clear
; 0000 0073         lcd_goto(0,0);
	CALL SUBOPT_0x5
; 0000 0074         if (pin_LC == 0)
	SBIC 0x9,2
	RJMP _0x93
; 0000 0075            lcd_puts("Calib C - open");
	__POINTW1MN _0x94,0
	RJMP _0xBA
; 0000 0076         else  lcd_puts("Calib L - short");
_0x93:
	__POINTW1MN _0x94,15
_0xBA:
	ST   -Y,R31
	ST   -Y,R30
	RCALL _lcd_puts
; 0000 0077         lcd_goto(0,1);
	CALL SUBOPT_0x4
; 0000 0078         lcd_puts("Wait...");
	__POINTW1MN _0x94,31
	CALL SUBOPT_0x3
; 0000 0079         Flag=1;
	LDI  R19,LOW(1)
; 0000 007A         for (Counter1 =0; Counter1 <= NMAX; Counter1++)
	LDI  R16,LOW(0)
_0x97:
	CPI  R16,9
	BRLO PC+3
	JMP _0x98
; 0000 007B           {
; 0000 007C             AdcRes = RchF(Counter1,NMAX);            // Calibration
	ST   -Y,R16
	LDI  R30,LOW(8)
	ST   -Y,R30
	CALL _RchF
	MOVW R20,R30
; 0000 007D             if (AdcRes < maxCAL)
	__CPWRN 20,21,192
	BRLO PC+3
	JMP _0x99
; 0000 007E               {
; 0000 007F                 if (pin_LC == 0)                     // Mode C
	SBIC 0x9,2
	RJMP _0x9A
; 0000 0080                   {
; 0000 0081                     CalC[Counter1] = (char)AdcRes;
	CALL SUBOPT_0x10
	MOVW R26,R28
	ADIW R26,21
	ADD  R30,R26
	ADC  R31,R27
	ST   Z,R20
; 0000 0082                     TMP = EEPROM_read(Counter1+1);
	CALL SUBOPT_0x10
	ADIW R30,1
	CALL SUBOPT_0xC
	MOV  R18,R30
; 0000 0083                     if (CalC[Counter1] != TMP)
	CALL SUBOPT_0x10
	CALL SUBOPT_0xD
	LD   R26,X
	CP   R18,R26
	BREQ _0x9B
; 0000 0084                        EEPROM_write((Counter1+1), CalC[Counter1]);
	CALL SUBOPT_0x10
	ADIW R30,1
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x10
	MOVW R26,R28
	ADIW R26,23
	CALL SUBOPT_0x11
; 0000 0085                   }
_0x9B:
; 0000 0086                 else                                 // Mode L
	RJMP _0x9C
_0x9A:
; 0000 0087                   {
; 0000 0088                     CalL[Counter1] = (char)AdcRes;
	CALL SUBOPT_0x10
	MOVW R26,R28
	ADIW R26,30
	ADD  R30,R26
	ADC  R31,R27
	ST   Z,R20
; 0000 0089                     TMP = EEPROM_read(Counter1+NMAX+2);
	CALL SUBOPT_0x10
	ADIW R30,10
	CALL SUBOPT_0xC
	MOV  R18,R30
; 0000 008A                     if (CalL[Counter1] != TMP)
	CALL SUBOPT_0x10
	CALL SUBOPT_0xF
	LD   R26,X
	CP   R18,R26
	BREQ _0x9D
; 0000 008B                        EEPROM_write(Counter1+NMAX+2, CalL[Counter1]);
	CALL SUBOPT_0x10
	ADIW R30,10
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x10
	MOVW R26,R28
	ADIW R26,32
	CALL SUBOPT_0x11
; 0000 008C                   }
_0x9D:
_0x9C:
; 0000 008D               }
; 0000 008E             else
	RJMP _0x9E
_0x99:
; 0000 008F               {
; 0000 0090                 Flag=0;                              // Error
	LDI  R19,LOW(0)
; 0000 0091                 if (pin_LC == 0)
	SBIC 0x9,2
	RJMP _0x9F
; 0000 0092                   CalC[Counter1] = defCAL;
	CALL SUBOPT_0x10
	MOVW R26,R28
	ADIW R26,21
	RJMP _0xBB
; 0000 0093                 else
_0x9F:
; 0000 0094                   CalL[Counter1] = defCAL;
	CALL SUBOPT_0x10
	MOVW R26,R28
	ADIW R26,30
_0xBB:
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(10)
	ST   X,R30
; 0000 0095               }
_0x9E:
; 0000 0096           }
	SUBI R16,-1
	RJMP _0x97
_0x98:
; 0000 0097         lcd_goto(0,1);
	CALL SUBOPT_0x4
; 0000 0098         if (Flag)
	CPI  R19,0
	BREQ _0xA1
; 0000 0099           lcd_puts("Done   ");
	__POINTW1MN _0x94,39
	RJMP _0xBC
; 0000 009A         else
_0xA1:
; 0000 009B           lcd_puts("Error ");
	__POINTW1MN _0x94,47
_0xBC:
	ST   -Y,R31
	ST   -Y,R30
	RCALL _lcd_puts
; 0000 009C 
; 0000 009D         delay_ms(1000);
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	CALL SUBOPT_0x1
; 0000 009E         lcd_clear();
	RCALL _lcd_clear
; 0000 009F         EIFR = 0x02;           // Clear flag INTF1
	LDI  R30,LOW(2)
	OUT  0x1C,R30
; 0000 00A0       }
; 0000 00A1 
; 0000 00A2 // Measuring C or L
; 0000 00A3     AdcRes = RchF(Ndiap,NMAX);
_0x8D:
	ST   -Y,R17
	LDI  R30,LOW(8)
	ST   -Y,R30
	CALL _RchF
	MOVW R20,R30
; 0000 00A4     Flag = 1;
	LDI  R19,LOW(1)
; 0000 00A5     if ((AdcRes > Umax) && (Ndiap < NMAX))
	__CPWRN 20,21,897
	BRLO _0xA4
	CPI  R17,8
	BRLO _0xA5
_0xA4:
	RJMP _0xA3
_0xA5:
; 0000 00A6       {
; 0000 00A7         lcd_frq(Ndiap,AdcRes);         // Freq and lim to display
	CALL SUBOPT_0x12
; 0000 00A8         ++Ndiap;
	SUBI R17,-LOW(1)
; 0000 00A9         Counter1 = 0;
	LDI  R16,LOW(0)
; 0000 00AA         Flag = 0;
	LDI  R19,LOW(0)
; 0000 00AB       }
; 0000 00AC     if ((AdcRes < Umin) && Ndiap)
_0xA3:
	__CPWRN 20,21,192
	BRSH _0xA7
	CPI  R17,0
	BRNE _0xA8
_0xA7:
	RJMP _0xA6
_0xA8:
; 0000 00AD       {
; 0000 00AE         lcd_frq(Ndiap,AdcRes);         // Freq and lim to display
	CALL SUBOPT_0x12
; 0000 00AF         --Ndiap;
	SUBI R17,LOW(1)
; 0000 00B0         Counter1 = 0;
	LDI  R16,LOW(0)
; 0000 00B1         Flag = 0;
	LDI  R19,LOW(0)
; 0000 00B2       }
; 0000 00B3     if (Flag)                          // L or C to display
_0xA6:
	CPI  R19,0
	BRNE PC+3
	JMP _0xA9
; 0000 00B4       {
; 0000 00B5         if (Counter1 < 8)
	CPI  R16,8
	BRSH _0xAA
; 0000 00B6          {
; 0000 00B7            lcd_frq(Ndiap,AdcRes);
	CALL SUBOPT_0x12
; 0000 00B8            Counter1++;
	SUBI R16,-1
; 0000 00B9          }
; 0000 00BA         else
	RJMP _0xAB
_0xAA:
; 0000 00BB            {
; 0000 00BC               lcd_spc(1);                 //Clear 1 line
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _lcd_spc
; 0000 00BD            }
_0xAB:
; 0000 00BE         Result = AdcRes;
	MOVW R30,R20
	CLR  R22
	CLR  R23
	__PUTD1S 17
; 0000 00BF 
; 0000 00C0 // +/- Calib value
; 0000 00C1         Flag = 0;                      // Sign "+"
	LDI  R19,LOW(0)
; 0000 00C2         if (pin_LC == 0)               // Mode "C"
	SBIC 0x9,2
	RJMP _0xAC
; 0000 00C3           {
; 0000 00C4             if (Result >= CalC[Ndiap]) Result = Result - CalC[Ndiap];
	CALL SUBOPT_0x13
	CALL SUBOPT_0x14
	BRLO _0xAD
	CALL SUBOPT_0x13
	CALL SUBOPT_0x15
; 0000 00C5             else
	RJMP _0xAE
_0xAD:
; 0000 00C6               {
; 0000 00C7                 Result = CalC[Ndiap] - Result;
	CALL SUBOPT_0x13
	CALL SUBOPT_0x16
; 0000 00C8                 Flag = 1;              // Sign "-"
; 0000 00C9               }
_0xAE:
; 0000 00CA           }
; 0000 00CB         else                           // Mode "L"
	RJMP _0xAF
_0xAC:
; 0000 00CC           {
; 0000 00CD             if (Result >= CalL[Ndiap]) Result = Result - CalL[Ndiap];
	CALL SUBOPT_0x17
	CALL SUBOPT_0x14
	BRLO _0xB0
	CALL SUBOPT_0x17
	CALL SUBOPT_0x15
; 0000 00CE             else
	RJMP _0xB1
_0xB0:
; 0000 00CF               {
; 0000 00D0                 Result = CalL[Ndiap] - Result;
	CALL SUBOPT_0x17
	CALL SUBOPT_0x16
; 0000 00D1                 Flag = 1;              // Sign "-"
; 0000 00D2               }
_0xB1:
; 0000 00D3           }
_0xAF:
; 0000 00D4 
; 0000 00D5         TMP = Ndiap;
	MOV  R18,R17
; 0000 00D6         while (TMP)                    // Count L or C
_0xB2:
	CPI  R18,0
	BREQ _0xB4
; 0000 00D7           {
; 0000 00D8             --TMP;
	SUBI R18,LOW(1)
; 0000 00D9             Result <<=2;               // *4
	__GETD2S 17
	LDI  R30,LOW(2)
	CALL __LSLD12
	__PUTD1S 17
; 0000 00DA           }
	RJMP _0xB2
_0xB4:
; 0000 00DB 
; 0000 00DC         ltoa(Result, strResult);  // long int to string
	__GETD1S 17
	CALL __PUTPARD1
	MOVW R30,R28
	ADIW R30,12
	ST   -Y,R31
	ST   -Y,R30
	CALL _ltoa
; 0000 00DD         TMP = prpeLC(strResult);  // Leave 3 significant digits, TMP=length of the string
	MOVW R30,R28
	ADIW R30,8
	ST   -Y,R31
	ST   -Y,R30
	RCALL _prpeLC
	MOV  R18,R30
; 0000 00DE         outIND(strResult, TMP, Flag);   // Output string to indicator
	MOVW R30,R28
	ADIW R30,8
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R18
	ST   -Y,R19
	RCALL _outIND
; 0000 00DF       }
; 0000 00E0   }
_0xA9:
	RJMP _0x89
; 0000 00E1 }
_0xB5:
	RJMP _0xB5

	.DSEG
_0x94:
	.BYTE 0x36
;

	.CSEG
_itoa:
    ld   r26,y+
    ld   r27,y+
    ld   r30,y+
    ld   r31,y+
    adiw r30,0
    brpl __itoa0
    com  r30
    com  r31
    adiw r30,1
    ldi  r22,'-'
    st   x+,r22
__itoa0:
    clt
    ldi  r24,low(10000)
    ldi  r25,high(10000)
    rcall __itoa1
    ldi  r24,low(1000)
    ldi  r25,high(1000)
    rcall __itoa1
    ldi  r24,100
    clr  r25
    rcall __itoa1
    ldi  r24,10
    rcall __itoa1
    mov  r22,r30
    rcall __itoa5
    clr  r22
    st   x,r22
    ret

__itoa1:
    clr	 r22
__itoa2:
    cp   r30,r24
    cpc  r31,r25
    brlo __itoa3
    inc  r22
    sub  r30,r24
    sbc  r31,r25
    brne __itoa2
__itoa3:
    tst  r22
    brne __itoa4
    brts __itoa5
    ret
__itoa4:
    set
__itoa5:
    subi r22,-0x30
    st   x+,r22
    ret
_ltoa:
	SBIW R28,4
	ST   -Y,R17
	ST   -Y,R16
	__GETD1N 0x3B9ACA00
	__PUTD1S 2
	LDI  R16,LOW(0)
	LDD  R26,Y+11
	TST  R26
	BRPL _0x2000003
	__GETD1S 8
	CALL __ANEGD1
	__PUTD1S 8
	CALL SUBOPT_0x18
	LDI  R30,LOW(45)
	ST   X,R30
_0x2000003:
_0x2000005:
	CALL SUBOPT_0x19
	CALL __DIVD21U
	MOV  R17,R30
	CPI  R17,0
	BRNE _0x2000008
	CPI  R16,0
	BRNE _0x2000008
	__GETD2S 2
	__CPD2N 0x1
	BRNE _0x2000007
_0x2000008:
	CALL SUBOPT_0x18
	MOV  R30,R17
	SUBI R30,-LOW(48)
	ST   X,R30
	LDI  R16,LOW(1)
_0x2000007:
	CALL SUBOPT_0x19
	CALL __MODD21U
	__PUTD1S 8
	__GETD2S 2
	__GETD1N 0xA
	CALL __DIVD21U
	__PUTD1S 2
	CALL __CPD10
	BRNE _0x2000005
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(0)
	ST   X,R30
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,12
	RET

	.DSEG

	.CSEG

	.CSEG
_strlen:
    ld   r26,y+
    ld   r27,y+
    clr  r30
    clr  r31
strlen0:
    ld   r22,x+
    tst  r22
    breq strlen1
    adiw r30,1
    rjmp strlen0
strlen1:
    ret

	.CSEG

	.CSEG

	.DSEG
__seed_G100:
	.BYTE 0x4

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x0:
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_write
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x1:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x2:
	CALL _LCD_STROBE
	LDI  R30,LOW(40)
	LDI  R31,HIGH(40)
	RJMP SUBOPT_0x1

;OPTIMIZER ADDED SUBROUTINE, CALLED 23 TIMES, CODE SIZE REDUCTION:41 WORDS
SUBOPT_0x3:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _lcd_puts

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x4:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _lcd_goto

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x5:
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R30
	JMP  _lcd_goto

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:25 WORDS
SUBOPT_0x6:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LD   R30,X
	ST   -Y,R30
	JMP  _lcd_putch

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x7:
	LDI  R30,LOW(46)
	ST   -Y,R30
	CALL _lcd_putch
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x8:
	LDD  R26,Z+1
	ST   -Y,R26
	CALL _lcd_putch
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	LDD  R26,Z+2
	ST   -Y,R26
	JMP  _lcd_putch

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x9:
	LDI  R30,LOW(32)
	ST   -Y,R30
	JMP  _lcd_putch

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xA:
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	LDD  R26,Z+1
	ST   -Y,R26
	JMP  _lcd_putch

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0xB:
	MOV  R30,R18
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xC:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _EEPROM_read

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0xD:
	MOVW R26,R28
	ADIW R26,21
	ADD  R26,R30
	ADC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xE:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(10)
	ST   -Y,R30
	JMP  _EEPROM_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0xF:
	MOVW R26,R28
	ADIW R26,30
	ADD  R26,R30
	ADC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0x10:
	MOV  R30,R16
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x11:
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	ST   -Y,R30
	JMP  _EEPROM_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x12:
	ST   -Y,R17
	ST   -Y,R21
	ST   -Y,R20
	JMP  _lcd_frq

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x13:
	MOV  R30,R17
	LDI  R31,0
	RJMP SUBOPT_0xD

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x14:
	LD   R30,X
	__GETD2S 17
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __CPD21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x15:
	LD   R30,X
	LDI  R31,0
	__GETD2S 17
	CALL __CWD1
	CALL __SUBD21
	__PUTD2S 17
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x16:
	LD   R26,X
	CLR  R27
	__GETD1S 17
	CALL __CWD2
	CALL __SUBD21
	__PUTD2S 17
	LDI  R19,LOW(1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x17:
	MOV  R30,R17
	LDI  R31,0
	RJMP SUBOPT_0xF

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x18:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,1
	STD  Y+6,R26
	STD  Y+6+1,R27
	SBIW R26,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x19:
	__GETD1S 2
	__GETD2S 8
	RET


	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0xFA0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__SUBD21:
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SBC  R25,R23
	RET

__ANEGD1:
	COM  R31
	COM  R22
	COM  R23
	NEG  R30
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__LSLD12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	MOVW R22,R24
	BREQ __LSLD12R
__LSLD12L:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R0
	BRNE __LSLD12L
__LSLD12R:
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__CWD2:
	MOV  R24,R27
	ADD  R24,R24
	SBC  R24,R24
	MOV  R25,R24
	RET

__DIVD21U:
	PUSH R19
	PUSH R20
	PUSH R21
	CLR  R0
	CLR  R1
	CLR  R20
	CLR  R21
	LDI  R19,32
__DIVD21U1:
	LSL  R26
	ROL  R27
	ROL  R24
	ROL  R25
	ROL  R0
	ROL  R1
	ROL  R20
	ROL  R21
	SUB  R0,R30
	SBC  R1,R31
	SBC  R20,R22
	SBC  R21,R23
	BRCC __DIVD21U2
	ADD  R0,R30
	ADC  R1,R31
	ADC  R20,R22
	ADC  R21,R23
	RJMP __DIVD21U3
__DIVD21U2:
	SBR  R26,1
__DIVD21U3:
	DEC  R19
	BRNE __DIVD21U1
	MOVW R30,R26
	MOVW R22,R24
	MOVW R26,R0
	MOVW R24,R20
	POP  R21
	POP  R20
	POP  R19
	RET

__MODD21U:
	RCALL __DIVD21U
	MOVW R30,R26
	MOVW R22,R24
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__CPD10:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	RET

__CPD21:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	CPC  R25,R23
	RET

__INITLOCB:
__INITLOCW:
	ADD  R26,R28
	ADC  R27,R29
__INITLOC0:
	LPM  R0,Z+
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

;END OF CODE MARKER
__END_OF_CODE:
