#pragma warn-             // this will prevent warnings
// Start measuring
unsigned int RchF(unsigned char Ndiap, unsigned char Nmax)
  {
#asm volatile

.equ   PINB = 0x03
.equ   PINB2 = 0x02
.equ   ADCL = 0x78
.equ   ADCH = 0x79
.equ   TCCR1B = 0x81
.equ   TCNT1L = 0x84
.equ   TCNT1H = 0x85
.equ   OCR1AL = 0x88
.equ   OCR1AH = 0x89
.equ   OCR1BL = 0x8A
.equ   OCR1BH = 0x8B

.equ   ConstF = 0x08      ; const for ~1MHz if CK=16MHz (0x0A for 800 KHz)
.equ   Conzad = 50        ; const: delay=Conzad*0,01 sec

       ld    R30,Y        ; Nmax
       ldd   R31,Y+1      ; Ndiap
       ldi   R26,ConstF   ; LSB ConstF
       clr   R27          ; MSB ConstF
       cp    R30,R31      ; Nmax-Ndiap
       brcc  RCH1         ; Ndiap=<Nmax
       mov   R31,R30      ; Ndiap>Nmax, so Ndiap=Nmax
RCH1:  mov   R25,R31      ; Ndiap, do not change R31
       ldi   R24,0x09     ; (CS12:CS10)=001, WGM12=1 - mode CTC, no prescaling
RCH4:  tst   R25
       breq  RCH2         ; R25=0
       dec   R25          ; counter
       clc                ; C=0
       rol   R26          ; (R27:R26)*2 (ConstF*2)
       rol   R27          ; ///////////
       brcc  RCH3         ; C=0
RCH5:  ror   R27          ; C=1, restore R27:R26
       ror   R26          ; ///////////
       inc   R25          ; restore R25
       rjmp  RCH2
RCH3:  rol   R26          ; (R27:R26)*2 (total (R27:R26)*4)
       rol   R27          ; ///////////
       brcc  RCH4         ; C=0, multiply once more
       breq  RCH2         ; R27=0 (and R26=0)
       ror   R27          ; C=1, restore R27:R26
       ror   R26          ; ///////////
       rjmp  RCH5
RCH2:  tst   R25
       breq  RCH6         ; R25=0, calculation completed
       ldi   R24,0x0C     ; (CS12:CS10)=100, WGM12=1 - mode CTC, prescaling 1/256
       mov   R26,R27      ; ConstF/256
       clr   R27          ; //////////
       rjmp  RCH4         ; continue calculating
RCH6:  sbiw  R26,0x01     ; (R27:R26)-1
       clr   R25
       sts   OCR1BH,R27
       sts   OCR1AH,R27
       sts   OCR1BL,R26
       sts   OCR1AL,R26
       sts   TCNT1H,R25
       sts   TCNT1L,R25
       sts   TCCR1B,R24   ; start TMR1

; Wait ~ 0,5 sec
       ldi   R25,Conzad
RCH10: ldi   R26,125
       clr   R27
RCH11: rjmp  PC+1
       dec   R27
       brne  RCH11
       dec   R26
       brne  RCH11        ; ~0,01 s
       dec   R25
       brne  RCH10        ; ~Conzad * 0,01 s
       subi  R30,2        ; Nmax-2
       cp    R31,R30      ; Ndiap-(Nmax-2)
       brcs  DACON        ; C=1, Ndiap<(Nmax-2)
       sbic  PINB,PINB2   ; PB2=0
       rjmp  PC-1         ; wait PB2=0
       sbis  PINB,PINB2   ; PB2=1
       rjmp  PC-1         ; wait PB2=1

; Wait ~6 ms
       ldi   R27,0x80
       clr   R26
RCH9:  dec   R26
       brne  RCH9
       dec   R27
       brne  RCH9
DACON: ldi   R27,0x03
       out   SMCR,R27     ; SLEEP - inable, ADC Noise Reduction
       sleep              ; start ADC
       ldi   R27,0x02     ; 0100.0011
       out   SMCR,R27     ; SLEEP - disable
       lds   R30,ADCL     ; LSB
       lds   R31,ADCH     ; MSB

#endasm
  }
#pragma warn+             // enable warnings

